import {
  scaleLinear,
  scaleTime,
  scaleOrdinal,
  max,
  extent,
  axisLeft,
  axisBottom,
  symbols,
  symbol,
} from 'd3';

import { curran } from './paths';

export const scatterPlot = () => {
  let width;
  let height;
  let data;
  let xValue;
  let yValue;
  let yAxisLabel="Curranians on VizHub Planet";
  let xAxisLabel="Date on Earth (Gregorian calendar)";
  let symbolValue;
  let margin;
  let size;

  const my = (selection) => {
    const x = scaleTime()
      .domain(extent(data, xValue))
      .range([margin.left, width - margin.right]);

    const y = scaleLinear()
      .domain([0,max(data, yValue)])
      .range([height - margin.bottom, margin.top]);
    
    // const symbolScale = scaleOrdinal()
    //   .domain(data.map(symbolValue))
    //   .range(symbols);

    // const symbolGenerator = symbol().size(size);
    
    const marks = data.map((d) => ({
      x: x(xValue(d)),
      y: y(yValue(d)),
      pathD: curran, //symbolGenerator.type(symbolScale(symbolValue(d)))()
    	title: `Total of ${yValue(d)} Curranians \nby ${xValue(d).toLocaleString('default', { day:'2-digit',month: 'long', year: 'numeric' })}`
    }));

    
    
//     selection
//       .selectAll('path')
//       .data(marks)
//       .join('path')
//       .attr('d', (d) => d.pathD)
//     	.attr('transform-origin','0 -15') // Also bad.
//       .attr('transform', (d) => `translate(${d.x},${d.y}) scale(.15)`) // USING SCALE HERE SMELLS SO WRONG!!!!
//     	.append('title')
//       	.text((d) => d.title);

    
    
    const curraniansG = selection
      .selectAll('g')
      .data(marks)
      .join('g')
    	.attr('transform-origin','center center') // Not working. Teakeak the rect and path with tranlate.
    	.attr('transform', (d) => `translate(${d.x},${d.y})`)
    	.attr('class','curranians');

    
    curraniansG.append('rect')
    	.attr('class','curranbg')
    	.attr('transform','translate(0 -7)')
    	.attr('width','10px')
    	.attr('height', '15px')
   		.append('title')
      	.text((d) => d.title);
    
    
    curraniansG.append('path')
      .attr('d', (d) => d.pathD)
    	 .attr('transform-origin','-0.15% -7') // Also bad.
      .attr('transform', (d) => `scale(.15)`) // USING SCALE HERE SMELLS SO WRONG!!!!

    
    const yAxisG = selection
      .append('g')
      .attr('transform', `translate(${margin.left},0)`)
    	.attr('class', 'yAxisG')
      .call(axisLeft(y));

    
      yAxisG.append('text')
      .attr('class', 'axis-label')
      .attr('y', -80)
      .attr('x', -height / 2)
      .attr('fill', 'black')
      .attr('transform', `rotate(-90)`)
      .attr('text-anchor', 'middle')
      .text(yAxisLabel);
    
    const xAxisG =selection
      .append('g')
      .attr(
        'transform',
        `translate(0,${height - margin.bottom})`
      )
      .call(axisBottom(x));
    
      xAxisG.append('text')
      .attr('class', 'axis-label')
      .attr('y', 50)
      .attr('x', '80%')
      .attr('fill', 'black')
      .text(xAxisLabel);
    
  };

  my.width = function (_) {
    return arguments.length ? ((width = +_), my) : width;
  };

  my.height = function (_) {
    return arguments.length ? ((height = +_), my) : height;
  };

  my.data = function (_) {
    return arguments.length ? ((data = _), my) : data;
  };

  my.xValue = function (_) {
    return arguments.length ? ((xValue = _), my) : xValue;
  };

  my.yValue = function (_) {
    return arguments.length ? ((yValue = _), my) : yValue;
  };

  my.symbolValue = function (_) {
    return arguments.length
      ? ((symbolValue = _), my)
      : symbolValue;
  };

  my.margin = function (_) {
    return arguments.length ? ((margin = _), my) : margin;
  };

  my.size = function (_) {
    return arguments.length ? ((size = +_), my) : size;
  };

  return my;
};
